unit PreprocessUses;

interface
uses sysutils,classes,lowx;
{
*I am changing the default name of pspwebcomponent units to
  PSP_WC[Objectname].pas 
 the old name was too long.
}
function ProduceUsesStatement (Data:String):String;

implementation

function ProcessUses (Data:String):String;
var outhold:String;
begin
 outhold:=GetTagProperty(Data,'COMPONENT','USES');
 if length(outhold)>0 then outhold:=outhold+',';
 outhold:=outhold+'classes,PSPBase';
 result:=outhold + #13+#10;
end;

function ProcessWCUses (Data:String):String;
var wclist:tstringlist; i:integer; fname,thiswc,outhold:String;
begin
wclist:=tstringlist.create;
wclist:=GetTermTagList (Data,'WEBCOMPONENT' );
for i:= 0 to wclist.count-1 do
 begin
  thiswc:=wclist[i];
  fname:= 'PSP_WC' + GetTagProperty (thiswc,'WEBCOMPONENT','FILE');
  {we don't want to add it if it is a blank (ie-local) file reference}
  if trim(fname)<>'PSP_WC' then outhold:=outhold+fname   ;
  if i<wclist.count-1 then outhold:=outhold+',' ;
  outhold:=outhold+#13+#10;
 end;
result:=outhold;
wclist.clear ;
wclist.free;
end;


function ProduceUsesStatement (Data:String):String;
var outhold,sUses,wcUses,delim:String;
begin
 {
  Pull all webcomponent FILE references, append "PSP_WC" to them,
  Pull USES tag  
 }
 sUses:=ProcessUses(data);
 wcUses:=ProcessWCUses (data);
 delim:='';
 {if there is something in both, we need to make sure we have a , separator}
 if ((trim(sUses)<>'') AND (trim(wcUses)<>'')) then delim:=',';
 
{
 now add all the strings together, and if anything is there, then we can write out
 the usesstatement, otherwise, just send nothing
}
 outhold:= trim(sUses) + delim + trim(wcuses);
 if trim(outhold)<>'' then outhold:='USES '+#13+#10+outhold+';'+#13+#10;
 result:=trim(outhold);
end;

end.